diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/theme-editor.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/theme-editor.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/theme-editor.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/theme-editor.php	2012-12-17 16:18:42.000000000 -0600
***************
*** 27,32 ****
--- 27,33 ----
  	'<p>' . __('You can use the Theme Editor to edit the individual CSS and PHP files which make up your theme.') . '</p>
  	<p>' . __('Begin by choosing a theme to edit from the dropdown menu and clicking Select. A list then appears of all the template files. Clicking once on any file name causes the file to appear in the large Editor box.') . '</p>
  	<p>' . __('For PHP files, you can use the Documentation dropdown to select from functions recognized in that file. Lookup takes you to a web page with reference material about that particular function.') . '</p>
+ 	<p id="newcontent-description">' . __('In the editing area the Tab key enters a tab character. To move below this area by pressing Tab, press the Esc key followed by the Tab key.') . '</p>
  	<p>' . __('After typing in your edits, click Update File.') . '</p>
  	<p>' . __('<strong>Advice:</strong> think very carefully about your site crashing if you are live-editing the theme currently in use.') . '</p>
  	<p>' . __('Upgrading to a newer version of the same theme will override changes made here. To avoid this, consider creating a <a href="http://codex.wordpress.org/Child_Themes" target="_blank">child theme</a> instead.') . '</p>' .
***************
*** 45,51 ****
  wp_reset_vars( array( 'action', 'error', 'file', 'theme' ) );
  
  if ( $theme )
! 	$stylesheet = urldecode( $theme );
  else
  	$stylesheet = get_stylesheet();
  
--- 46,52 ----
  wp_reset_vars( array( 'action', 'error', 'file', 'theme' ) );
  
  if ( $theme )
! 	$stylesheet = $theme;
  else
  	$stylesheet = get_stylesheet();
  
***************
*** 67,73 ****
  	$relative_file = 'style.css';
  	$file = $allowed_files['style.css'];
  } else {
! 	$relative_file = urldecode( stripslashes( $file ) );
  	$file = $theme->get_stylesheet_directory() . '/' . $relative_file;
  }
  
--- 68,74 ----
  	$relative_file = 'style.css';
  	$file = $allowed_files['style.css'];
  } else {
! 	$relative_file = stripslashes( $file );
  	$file = $theme->get_stylesheet_directory() . '/' . $relative_file;
  }
  
***************
*** 198,209 ****
  else : ?>
  	<form name="template" id="template" action="theme-editor.php" method="post">
  	<?php wp_nonce_field( 'edit-theme_' . $file . $stylesheet ); ?>
! 		 <div><textarea cols="70" rows="30" name="newcontent" id="newcontent" tabindex="1"><?php echo $content ?></textarea>
! 		 <input type="hidden" name="action" value="update" />
! 		 <input type="hidden" name="file" value="<?php echo esc_attr( $relative_file ); ?>" />
! 		 <input type="hidden" name="theme" value="<?php echo esc_attr( $theme->get_stylesheet() ); ?>" />
! 		 <input type="hidden" name="scrollto" id="scrollto" value="<?php echo $scrollto; ?>" />
! 		 </div>
  	<?php if ( ! empty( $functions ) ) : ?>
  		<div id="documentation" class="hide-if-no-js">
  		<label for="docs-list"><?php _e('Documentation:') ?></label>
--- 199,210 ----
  else : ?>
  	<form name="template" id="template" action="theme-editor.php" method="post">
  	<?php wp_nonce_field( 'edit-theme_' . $file . $stylesheet ); ?>
! 		<div><textarea cols="70" rows="30" name="newcontent" id="newcontent" aria-describedby="newcontent-description"><?php echo $content; ?></textarea>
! 		<input type="hidden" name="action" value="update" />
! 		<input type="hidden" name="file" value="<?php echo esc_attr( $relative_file ); ?>" />
! 		<input type="hidden" name="theme" value="<?php echo esc_attr( $theme->get_stylesheet() ); ?>" />
! 		<input type="hidden" name="scrollto" id="scrollto" value="<?php echo $scrollto; ?>" />
! 		</div>
  	<?php if ( ! empty( $functions ) ) : ?>
  		<div id="documentation" class="hide-if-no-js">
  		<label for="docs-list"><?php _e('Documentation:') ?></label>
***************
*** 219,225 ****
  		<?php endif; ?>
  <?php
  	if ( is_writeable( $file ) ) :
! 		submit_button( __( 'Update File' ), 'primary', 'submit', true, array( 'tabindex' => '2' ) );
  	else : ?>
  <p><em><?php _e('You need to make this file writable before you can save your changes. See <a href="http://codex.wordpress.org/Changing_File_Permissions">the Codex</a> for more information.'); ?></em></p>
  <?php endif; ?>
--- 220,226 ----
  		<?php endif; ?>
  <?php
  	if ( is_writeable( $file ) ) :
! 		submit_button( __( 'Update File' ), 'primary', 'submit', true );
  	else : ?>
  <p><em><?php _e('You need to make this file writable before you can save your changes. See <a href="http://codex.wordpress.org/Changing_File_Permissions">the Codex</a> for more information.'); ?></em></p>
  <?php endif; ?>
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/theme-install.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/theme-install.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/theme-install.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/theme-install.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 49,55 ****
  
  $help_installing =
  	'<p>' . __('Once you have generated a list of themes, you can preview and install any of them. Click on the thumbnail of the theme you&#8217;re interested in previewing. It will open up in a full-screen Preview page to give you a better idea of how that theme will look.') . '</p>' .
! 	'<p>' . __('To install the theme so you can preview it with your site&#8217;s content and customize its theme options, click the "Install" button at the top of the left-hand pane. The theme files will be downloaded to your website automatically. When this is complete, the theme is now available for activation, which you can do by clicking the "Activate" link, or by navigating to your Installed Themes page and clicking the "Live Preview" link under any installed theme&#8217;s thumbnail image.') . '</p>';
  
  get_current_screen()->add_help_tab( array(
  	'id'      => 'installing',
--- 49,55 ----
  
  $help_installing =
  	'<p>' . __('Once you have generated a list of themes, you can preview and install any of them. Click on the thumbnail of the theme you&#8217;re interested in previewing. It will open up in a full-screen Preview page to give you a better idea of how that theme will look.') . '</p>' .
! 	'<p>' . __('To install the theme so you can preview it with your site&#8217;s content and customize its theme options, click the "Install" button at the top of the left-hand pane. The theme files will be downloaded to your website automatically. When this is complete, the theme is now available for activation, which you can do by clicking the "Activate" link, or by navigating to your Manage Themes screen and clicking the "Live Preview" link under any installed theme&#8217;s thumbnail image.') . '</p>';
  
  get_current_screen()->add_help_tab( array(
  	'id'      => 'installing',
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/themes.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/themes.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/themes.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/themes.php	2012-12-17 16:18:42.000000000 -0600
***************
*** 20,26 ****
  		$theme = wp_get_theme( $_GET['stylesheet'] );
  		if ( ! $theme->exists() || ! $theme->is_allowed() )
  			wp_die( __( 'Cheatin&#8217; uh?' ) );
! 		switch_theme( $theme->get_template(), $theme->get_stylesheet() );
  		wp_redirect( admin_url('themes.php?activated=true') );
  		exit;
  	} elseif ( 'delete' == $_GET['action'] ) {
--- 20,26 ----
  		$theme = wp_get_theme( $_GET['stylesheet'] );
  		if ( ! $theme->exists() || ! $theme->is_allowed() )
  			wp_die( __( 'Cheatin&#8217; uh?' ) );
! 		switch_theme( $theme->get_stylesheet() );
  		wp_redirect( admin_url('themes.php?activated=true') );
  		exit;
  	} elseif ( 'delete' == $_GET['action'] ) {
***************
*** 108,117 ****
  <div id="message1" class="updated"><p><?php _e('The active theme is broken. Reverting to the default theme.'); ?></p></div>
  <?php elseif ( isset($_GET['activated']) ) :
  		if ( isset( $_GET['previewed'] ) ) { ?>
! 		<div id="message2" class="updated"><p><?php printf( __( 'Settings saved and theme activated. <a href="%s">Visit site</a>.' ), home_url( '/' ) ); ?></p></div>
! 		<?php } elseif ( isset($wp_registered_sidebars) && count( (array) $wp_registered_sidebars ) && current_user_can('edit_theme_options') ) { ?>
! <div id="message2" class="updated"><p><?php printf( __('New theme activated. This theme supports widgets, please visit the <a href="%s">widgets settings</a> screen to configure them.'), admin_url( 'widgets.php' ) ); ?></p></div><?php
! 		} else { ?>
  <div id="message2" class="updated"><p><?php printf( __( 'New theme activated. <a href="%s">Visit site</a>' ), home_url( '/' ) ); ?></p></div><?php
  		}
  	elseif ( isset($_GET['deleted']) ) : ?>
--- 108,115 ----
  <div id="message1" class="updated"><p><?php _e('The active theme is broken. Reverting to the default theme.'); ?></p></div>
  <?php elseif ( isset($_GET['activated']) ) :
  		if ( isset( $_GET['previewed'] ) ) { ?>
! 		<div id="message2" class="updated"><p><?php printf( __( 'Settings saved and theme activated. <a href="%s">Visit site</a>' ), home_url( '/' ) ); ?></p></div>
! 		<?php } else { ?>
  <div id="message2" class="updated"><p><?php printf( __( 'New theme activated. <a href="%s">Visit site</a>' ), home_url( '/' ) ); ?></p></div><?php
  		}
  	elseif ( isset($_GET['deleted']) ) : ?>
***************
*** 147,152 ****
--- 145,155 ----
  			<li><?php printf( __('Version %s'), $ct->display('Version') ); ?></li>
  		</ul>
  		<p class="theme-description"><?php echo $ct->display('Description'); ?></p>
+ 		<?php if ( $ct->parent() ) {
+ 			printf( ' <p class="howto">' . __( 'This <a href="%1$s">child theme</a> requires its parent theme, %2$s.' ) . '</p>',
+ 				__( 'http://codex.wordpress.org/Child_Themes' ),
+ 				$ct->parent()->display( 'Name' ) );
+ 		} ?>
  		<?php theme_update_available( $ct ); ?>
  	</div>
  
***************
*** 169,175 ****
  				else
  					$options[] = "<a href='{$submenu[$item[2]][0][2]}'$class>{$item[0]}</a>";
  			} else if ( current_user_can($item[1]) ) {
! 				if ( file_exists(ABSPATH . 'wp-admin/' . $item[2]) ) {
  					$options[] = "<a href='{$item[2]}'$class>{$item[0]}</a>";
  				} else {
  					$options[] = "<a href='themes.php?page={$item[2]}'$class>{$item[0]}</a>";
--- 172,181 ----
  				else
  					$options[] = "<a href='{$submenu[$item[2]][0][2]}'$class>{$item[0]}</a>";
  			} else if ( current_user_can($item[1]) ) {
! 				$menu_file = $item[2];
! 				if ( false !== ( $pos = strpos( $menu_file, '?' ) ) )
! 					$menu_file = substr( $menu_file, 0, $pos );
! 				if ( file_exists( ABSPATH . "wp-admin/$menu_file" ) ) {
  					$options[] = "<a href='{$item[2]}'$class>{$item[0]}</a>";
  				} else {
  					$options[] = "<a href='themes.php?page={$item[2]}'$class>{$item[0]}</a>";
***************
*** 193,201 ****
  				<li><?php echo $option; ?></li>
  			<?php endforeach; ?>
  		</ul>
  	</div>
  	<?php
- 		endif; // options
  	endif; // options || edit_theme_options
  	?>
  
--- 199,209 ----
  				<li><?php echo $option; ?></li>
  			<?php endforeach; ?>
  		</ul>
+ 		<?php
+ 		endif; // options
+ 		?>
  	</div>
  	<?php
  	endif; // options || edit_theme_options
  	?>
  
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/update-core.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/update-core.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/update-core.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/update-core.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 18,24 ****
  	exit();
  }
  
! if ( ! current_user_can( 'update_core' ) )
  	wp_die( __( 'You do not have sufficient permissions to update this site.' ) );
  
  function list_core_update( $update ) {
--- 18,24 ----
  	exit();
  }
  
! if ( ! current_user_can( 'update_core' ) && ! current_user_can( 'update_themes' ) && ! current_user_can( 'update_plugins' ) )
  	wp_die( __( 'You do not have sufficient permissions to update this site.' ) );
  
  function list_core_update( $update ) {
***************
*** 74,80 ****
  	echo '<input name="locale" value="'. esc_attr($update->locale) .'" type="hidden"/>';
  	if ( $show_buttons ) {
  		if ( $first_pass ) {
! 			submit_button( $submit, $current ? 'button' : 'primary', 'upgrade', false );
  			$first_pass = false;
  		} else {
  			submit_button( $submit, 'button', 'upgrade', false );
--- 74,80 ----
  	echo '<input name="locale" value="'. esc_attr($update->locale) .'" type="hidden"/>';
  	if ( $show_buttons ) {
  		if ( $first_pass ) {
! 			submit_button( $submit, $current ? 'button' : 'primary regular', 'upgrade', false );
  			$first_pass = false;
  		} else {
  			submit_button( $submit, 'button', 'upgrade', false );
***************
*** 131,158 ****
   * @return null
   */
  function core_upgrade_preamble() {
! 	global $upgrade_error, $wp_version;
  
  	$updates = get_core_updates();
- ?>
- 	<div class="wrap">
- 	<?php screen_icon('tools'); ?>
- 	<h2><?php _e('WordPress Updates'); ?></h2>
- <?php
- 	if ( $upgrade_error ) {
- 		echo '<div class="error"><p>';
- 		if ( $upgrade_error == 'themes' )
- 			_e('Please select one or more themes to update.');
- 		else
- 			_e('Please select one or more plugins to update.');
- 		echo '</p></div>';
- 	}
- 
- 	echo '<p>';
- 	/* translators: %1 date, %2 time. */
- 	printf( __('Last checked on %1$s at %2$s.'), date_i18n( get_option( 'date_format' ) ), date_i18n( get_option( 'time_format' ) ) );
- 	echo ' &nbsp; <a class="button" href="' . esc_url( self_admin_url('update-core.php') ) . '">' . __( 'Check Again' ) . '</a>';
- 	echo '</p>';
  
  	if ( !isset($updates[0]->response) || 'latest' == $updates[0]->response ) {
  		echo '<h3>';
--- 131,139 ----
   * @return null
   */
  function core_upgrade_preamble() {
! 	global $wp_version;
  
  	$updates = get_core_updates();
  
  	if ( !isset($updates[0]->response) || 'latest' == $updates[0]->response ) {
  		echo '<h3>';
***************
*** 183,195 ****
  		echo '<p>' . sprintf( __( '<a href="%s">Learn more about WordPress %s</a>.' ), esc_url( self_admin_url( 'about.php' ) ), $normalized_version ) . '</p>';
  	}
  	dismissed_updates();
- 
- 	if ( current_user_can( 'update_plugins' ) )
- 		list_plugin_updates();
- 	if ( current_user_can( 'update_themes' ) )
- 		list_theme_updates();
- 	do_action('core_upgrade_preamble');
- 	echo '</div>';
  }
  
  function list_plugin_updates() {
--- 164,169 ----
***************
*** 380,386 ****
  	}
  
  	show_message( __('WordPress updated successfully') );
! 	show_message( '<span class="hide-if-no-js">' . sprintf( __( 'Welcome to WordPress %1$s. You will be redirected to the About WordPress screen. If not, click <a href="%s">here</a>.' ), $result, esc_url( self_admin_url( 'about.php?updated' ) ) ) . '</span>' );
  	show_message( '<span class="hide-if-js">' . sprintf( __( 'Welcome to WordPress %1$s. <a href="%2$s">Learn more</a>.' ), $result, esc_url( self_admin_url( 'about.php?updated' ) ) ) . '</span>' );
  	?>
  	</div>
--- 354,360 ----
  	}
  
  	show_message( __('WordPress updated successfully') );
! 	show_message( '<span class="hide-if-no-js">' . sprintf( __( 'Welcome to WordPress %1$s. You will be redirected to the About WordPress screen. If not, click <a href="%2$s">here</a>.' ), $result, esc_url( self_admin_url( 'about.php?updated' ) ) ) . '</span>' );
  	show_message( '<span class="hide-if-js">' . sprintf( __( 'Welcome to WordPress %1$s. <a href="%2$s">Learn more</a>.' ), $result, esc_url( self_admin_url( 'about.php?updated' ) ) ) . '</span>' );
  	?>
  	</div>
***************
*** 454,463 ****
  
  	wp_version_check();
  	require_once(ABSPATH . 'wp-admin/admin-header.php');
! 	core_upgrade_preamble();
  	include(ABSPATH . 'wp-admin/admin-footer.php');
  
  } elseif ( 'do-core-upgrade' == $action || 'do-core-reinstall' == $action ) {
  	check_admin_referer('upgrade-core');
  
  	// do the (un)dismiss actions before headers,
--- 428,468 ----
  
  	wp_version_check();
  	require_once(ABSPATH . 'wp-admin/admin-header.php');
! 	?>
! 	<div class="wrap">
! 	<?php screen_icon('tools'); ?>
! 	<h2><?php _e('WordPress Updates'); ?></h2>
! 	<?php
! 	if ( $upgrade_error ) {
! 		echo '<div class="error"><p>';
! 		if ( $upgrade_error == 'themes' )
! 			_e('Please select one or more themes to update.');
! 		else
! 			_e('Please select one or more plugins to update.');
! 		echo '</p></div>';
! 	}
! 
! 	echo '<p>';
! 	/* translators: %1 date, %2 time. */
! 	printf( __('Last checked on %1$s at %2$s.'), date_i18n( get_option( 'date_format' ) ), date_i18n( get_option( 'time_format' ) ) );
! 	echo ' &nbsp; <a class="button" href="' . esc_url( self_admin_url('update-core.php') ) . '">' . __( 'Check Again' ) . '</a>';
! 	echo '</p>';
! 
! 	if ( current_user_can( 'update_core' ) )
! 		core_upgrade_preamble();
! 	if ( current_user_can( 'update_plugins' ) )
! 		list_plugin_updates();
! 	if ( current_user_can( 'update_themes' ) )
! 		list_theme_updates();
! 	do_action('core_upgrade_preamble');
! 	echo '</div>';
  	include(ABSPATH . 'wp-admin/admin-footer.php');
  
  } elseif ( 'do-core-upgrade' == $action || 'do-core-reinstall' == $action ) {
+ 
+ 	if ( ! current_user_can( 'update_core' ) )
+ 		wp_die( __( 'You do not have sufficient permissions to update this site.' ) );
+ 
  	check_admin_referer('upgrade-core');
  
  	// do the (un)dismiss actions before headers,
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/update.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/update.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/update.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/update.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 90,96 ****
  	} elseif ( 'install-plugin' == $action ) {
  
  		if ( ! current_user_can('install_plugins') )
! 			wp_die(__('You do not have sufficient permissions to install plugins for this site.'));
  
  		include_once ABSPATH . 'wp-admin/includes/plugin-install.php'; //for plugins_api..
  
--- 90,96 ----
  	} elseif ( 'install-plugin' == $action ) {
  
  		if ( ! current_user_can('install_plugins') )
! 			wp_die( __( 'You do not have sufficient permissions to install plugins on this site.' ) );
  
  		include_once ABSPATH . 'wp-admin/includes/plugin-install.php'; //for plugins_api..
  
***************
*** 121,127 ****
  	} elseif ( 'upload-plugin' == $action ) {
  
  		if ( ! current_user_can('install_plugins') )
! 			wp_die(__('You do not have sufficient permissions to install plugins for this site.'));
  
  		check_admin_referer('plugin-upload');
  
--- 121,127 ----
  	} elseif ( 'upload-plugin' == $action ) {
  
  		if ( ! current_user_can('install_plugins') )
! 			wp_die( __( 'You do not have sufficient permissions to install plugins on this site.' ) );
  
  		check_admin_referer('plugin-upload');
  
***************
*** 194,200 ****
  	} elseif ( 'install-theme' == $action ) {
  
  		if ( ! current_user_can('install_themes') )
! 			wp_die(__('You do not have sufficient permissions to install themes for this site.'));
  
  		include_once ABSPATH . 'wp-admin/includes/theme-install.php'; //for themes_api..
  
--- 194,200 ----
  	} elseif ( 'install-theme' == $action ) {
  
  		if ( ! current_user_can('install_themes') )
! 			wp_die( __( 'You do not have sufficient permissions to install themes on this site.' ) );
  
  		include_once ABSPATH . 'wp-admin/includes/theme-install.php'; //for themes_api..
  
***************
*** 224,230 ****
  	} elseif ( 'upload-theme' == $action ) {
  
  		if ( ! current_user_can('install_themes') )
! 			wp_die(__('You do not have sufficient permissions to install themes for this site.'));
  
  		check_admin_referer('theme-upload');
  
--- 224,230 ----
  	} elseif ( 'upload-theme' == $action ) {
  
  		if ( ! current_user_can('install_themes') )
! 			wp_die( __( 'You do not have sufficient permissions to install themes on this site.' ) );
  
  		check_admin_referer('theme-upload');
  
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/upgrade.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/upgrade.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/upgrade.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/upgrade.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 17,22 ****
--- 17,24 ----
  /** Load WordPress Bootstrap */
  require( '../wp-load.php' );
  
+ nocache_headers();
+ 
  timer_start();
  require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
  
***************
*** 55,68 ****
  	wp_admin_css( 'ie', true );
  	?>
  </head>
! <body>
! <h1 id="logo"><img alt="WordPress" src="images/wordpress-logo.png?ver=20120216" /></h1>
  
  <?php if ( get_option( 'db_version' ) == $wp_db_version || !is_blog_installed() ) : ?>
  
  <h2><?php _e( 'No Update Required' ); ?></h2>
  <p><?php _e( 'Your WordPress database is already up-to-date!' ); ?></p>
! <p class="step"><a class="button" href="<?php echo get_option( 'home' ); ?>/"><?php _e( 'Continue' ); ?></a></p>
  
  <?php elseif ( !$php_compat || !$mysql_compat ) :
  	if ( !$mysql_compat && !$php_compat )
--- 57,70 ----
  	wp_admin_css( 'ie', true );
  	?>
  </head>
! <body class="wp-core-ui">
! <h1 id="logo"><a href="<?php esc_attr_e( 'http://wordpress.org/' ); ?>"><?php _e( 'WordPress' ); ?></a></h1>
  
  <?php if ( get_option( 'db_version' ) == $wp_db_version || !is_blog_installed() ) : ?>
  
  <h2><?php _e( 'No Update Required' ); ?></h2>
  <p><?php _e( 'Your WordPress database is already up-to-date!' ); ?></p>
! <p class="step"><a class="button button-large" href="<?php echo get_option( 'home' ); ?>/"><?php _e( 'Continue' ); ?></a></p>
  
  <?php elseif ( !$php_compat || !$mysql_compat ) :
  	if ( !$mysql_compat && !$php_compat )
***************
*** 82,88 ****
  <h2><?php _e( 'Database Update Required' ); ?></h2>
  <p><?php _e( 'WordPress has been updated! Before we send you on your way, we have to update your database to the newest version.' ); ?></p>
  <p><?php _e( 'The update process may take a little while, so please be patient.' ); ?></p>
! <p class="step"><a class="button" href="upgrade.php?step=1&amp;backto=<?php echo $goback; ?>"><?php _e( 'Update WordPress Database' ); ?></a></p>
  <?php
  		break;
  	case 1:
--- 84,90 ----
  <h2><?php _e( 'Database Update Required' ); ?></h2>
  <p><?php _e( 'WordPress has been updated! Before we send you on your way, we have to update your database to the newest version.' ); ?></p>
  <p><?php _e( 'The update process may take a little while, so please be patient.' ); ?></p>
! <p class="step"><a class="button button-large" href="upgrade.php?step=1&amp;backto=<?php echo $goback; ?>"><?php _e( 'Update WordPress Database' ); ?></a></p>
  <?php
  		break;
  	case 1:
***************
*** 94,100 ****
  ?>
  <h2><?php _e( 'Update Complete' ); ?></h2>
  	<p><?php _e( 'Your WordPress database has been successfully updated!' ); ?></p>
! 	<p class="step"><a class="button" href="<?php echo $backto; ?>"><?php _e( 'Continue' ); ?></a></p>
  
  <!--
  <pre>
--- 96,102 ----
  ?>
  <h2><?php _e( 'Update Complete' ); ?></h2>
  	<p><?php _e( 'Your WordPress database has been successfully updated!' ); ?></p>
! 	<p class="step"><a class="button button-large" href="<?php echo $backto; ?>"><?php _e( 'Continue' ); ?></a></p>
  
  <!--
  <pre>
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/upload.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/upload.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/upload.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/upload.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 57,63 ****
  			if ( !$parent_id )
  				return;
  
! 			$parent = &get_post( $parent_id );
  			if ( !current_user_can( 'edit_post', $parent_id ) )
  				wp_die( __( 'You are not allowed to edit this post.' ) );
  
--- 57,63 ----
  			if ( !$parent_id )
  				return;
  
! 			$parent = get_post( $parent_id );
  			if ( !current_user_can( 'edit_post', $parent_id ) )
  				wp_die( __( 'You are not allowed to edit this post.' ) );
  
***************
*** 69,80 ****
  					continue;
  
  				$attach[] = $att_id;
- 				clean_attachment_cache( $att_id );
  			}
  
  			if ( ! empty( $attach ) ) {
! 				$attach = implode( ',', $attach );
! 				$attached = $wpdb->query( $wpdb->prepare( "UPDATE $wpdb->posts SET post_parent = %d WHERE post_type = 'attachment' AND ID IN ( $attach )", $parent_id ) );
  			}
  
  			if ( isset( $attached ) ) {
--- 69,82 ----
  					continue;
  
  				$attach[] = $att_id;
  			}
  
  			if ( ! empty( $attach ) ) {
! 				$attach_string = implode( ',', $attach );
! 				$attached = $wpdb->query( $wpdb->prepare( "UPDATE $wpdb->posts SET post_parent = %d WHERE post_type = 'attachment' AND ID IN ( $attach_string )", $parent_id ) );
! 				foreach ( $attach as $att_id ) {
! 					clean_attachment_cache( $att_id );
! 				}
  			}
  
  			if ( isset( $attached ) ) {
